from osgeo import ogr
def getFeatureCount(ds,name_layer):
    sql="Select Count(*) as cnt from "+name_layer
    layer_cnt=ds.ExecuteSQL(sql,None,dialect='SQLite')
    ft=layer_cnt.GetNextFeature()
    count=ft.GetField('cnt')
    layer_cnt=None
    return count
class OvershotClip:
    def __init__(self,ds):
        self.__ds=ds
        self.__layer=ds.GetLayer(0)
        self.__name_gometry=self.__layer.GetGeometryColumn()
        self.__name_fid = self.__layer.GetFIDColumn()
        self.__layer_name=self.__layer.GetName()

    def run(self):
        count_ft=self.__layer.GetFeatureCount()

        for i in range(count_ft):

            fid=i+1
            layer_intersect=self.__findIntersections(fid)
    def __findIntersections(self,curent_fid):
        sql_format_base_patern = "select * from {name} where {name}.{id}={id_value}"
        sql_format_base = sql_format_base_patern.format(name=self.__layer_name, id=self.__name_fid, id_value=str(curent_fid))
        sql_patern_next = "select * from {name} where {name}.{id}>{id_value}"
        sql_next = sql_patern_next.format(name=self.__layer_name, id=self.__name_fid, id_value=str(curent_fid))
        sql_full_patern = "select t_base.{id} as child_id,ST_Intersection(t."+self.__name_gometry+",t_base."+self.__name_gometry+") as "+self.__name_gometry+" from ({sql_1}) as t ,({sql_2}) as t_base where  ST_Intersects(t."+self.__name_gometry+",t_base."+self.__name_gometry+")"
        sql_full = sql_full_patern.format(id=self.__name_fid, sql_1=sql_format_base, sql_2=sql_next)
        layer_intersect=self.__ds.ExecuteSQL(sql_full,None,dialect='SQLite')
        count_intersect=layer_intersect.GetFeatureCount()
        for i in range(count_intersect):
            ft=layer_intersect.GetFeature(i)
            cur_id=ft.GetFID()
            ()
        return layer_intersect
    def close(self):
        if self.__layer is not None:
            self.__layer=None
path_db=r"E:\Support\AxiomaTesting\CutLine\StreetGSK7.sqlite"
path_db=r"E:\Support\AxiomaTesting\CutLine\Test_1dbS.sqlite"
ds=ogr.Open(path_db,1)

cls_overShot=OvershotClip(ds)
cls_overShot.run()
cls_overShot.close()
ds=None