from axipy import data_manager, TypeSqlDialect


def findIntersections(tab_name,name_id,value_id):
    sql_format_base_patern="select * from {name} where {name}.{id}={id_value}"
    sql_format_base=sql_format_base_patern.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_patern_next="select * from {name} where {name}.{id}>{id_value}"
    sql_next=sql_patern_next.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_full_patern="select t_base.{id},ToAxiGeo(Intersection(FromAxiGeo(t.obj),FromAxiGeo(t_base.obj))) as obj from ({sql_1}) as t ,({sql_2}) as t_base where  ST_Intersects(FromAxiGeo(t.obj),FromAxiGeo(t_base.obj))"
    sql_full=sql_full_patern.format(id=name_id,sql_1=sql_format_base,sql_2=sql_next)
    query = data_manager.query(sql_full, TypeSqlDialect.sqlite)
    return query
def CutPolyLineObject(table_base,name_id,cur_id,tab_query,row_id):
    sql_format_base_patern="select * from {name} where {name}.{id}={id_value}"
    sql_1=sql_format_base_patern.format(name=table_base.name,id=name_id,id_value=str(cur_id))
    sql_2 = sql_format_base_patern.format(name=tab_query.name, id='rowid', id_value=str(row_id))
    sql_result_patern="select t_base.{id},ToAxiGeo(LinesCutAtNodes(FromAxiGeo(t_base.obj),FromAxiGeo(t.obj))) as obj from ({sql_1}) as t ,({sql_2}) as t_base"
    sql_result=sql_result_patern.format(id=name_id,sql_1=sql_1,sql_2=sql_2)
    query_result=data_manager.query(sql_result)
    ()
def CutPolyLineObjectAll(table_base,tab_intersect,name_id,cur_id_base):
    for i,ft in enumerate(tab_intersect.items()):
        CutPolyLineObject(table_base,name_id,cur_id_base,tab_intersect,i+1)


def OvershotClip(name_base_tab,name_id):
    ''' Поиск пересечений и разрыв в точках пересечений'''
    tab_base=data_manager.find(name_base_tab)
    for ft in tab_base.items():
        id_val=ft[name_id]
        query=findIntersections(name_base_tab,name_id,id_val)
        if query.count()==0:
            query.close()
        CutPolyLineObjectAll( tab_base,query,name_id,id_val)
#name_q_1=findIntersections(name_tab,"id",1)
#name_q_2=findIntersections(name_tab,"id",2)
name_tab='Test_1'
OvershotClip(name_tab,"id")
