from axipy import data_manager, TypeSqlDialect
from datetime import datetime
def findIntersectionsNoSql(table,ft_curent,name_id,id_val):
    cur_geometry=ft_curent.geometry
    list_id=[]
    for ft in table.items(cur_geometry.bounds):
        if ft[name_id]<=id_val:
            continue
        obj_intersect= cur_geometry.intersects(ft.geometry)
        if not obj_intersect:
            continue
        list_id.append({'children_id':ft[name_id],'geometry':ft.geometry})
    return list_id

name_table='StreetGSK7_v_test_no_poligon'
sql_prepare = "Select RowNum() as id___dxx,* From " + name_table
name_id='id___dxx'
tab_id=data_manager.query(sql_prepare,TypeSqlDialect.sqlite)
tab_base = tab_id
count_row=tab_base.count()
i=0
start_time=datetime.now()
count_lim=100
for ft in tab_base.items():
    i=i+1
    if i>count_lim:
        break
    id_val = ft[name_id]
    #query = findIntersections(tab_id.name, name_id, id_val)
    lisi_id=findIntersectionsNoSql(tab_base,ft,name_id, id_val)
    ()

tab_id.close()
end_time=datetime.now()
print("Time find:"+str(end_time-start_time))