from axipy import data_manager, TypeSqlDialect, Unit


def getFeature(name_tab,name_id,value_id):
    sql="Select * from "+name_tab+" where "+name_id+"="+str(value_id)
    query = data_manager.query(sql, TypeSqlDialect.axioma)
    fts=list(query.items())
    return fts[0],query.name
name_tab='test_distance'
name_id='id'
ft_1,name_query_1=getFeature(name_tab,name_id,28)
ft_2,name_query_2=getFeature(name_tab,name_id,16)
geo_1=ft_1.geometry
geo_2=ft_2.geometry
dist=geo_1.get_distance(geo_2,Unit.m)
print("distance axiPy="+str(dist))
sql_dist='Select Distance(t1.obj,t2.obj,"m") as axi_dist from '+name_query_1+" as t1 ,"+name_query_2+" as t2 where t1.obj<>t2.obj"
query = data_manager.query(sql_dist, TypeSqlDialect.sqlite)
fts_dist=list(query.items())
ft=fts_dist[0]
dist_query=ft['axi_dist']
print("Sql dist="+str(dist_query))
