from axipy import data_manager, TypeSqlDialect
from datetime import datetime
def findIntersections(tab_name,name_id,value_id):
    sql_format_base_patern="select * from {name} where {name}.{id}={id_value}"
    sql_format_base=sql_format_base_patern.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_patern_next="select * from {name} where {name}.{id}>{id_value}"
    sql_next=sql_patern_next.format(name=tab_name,id=name_id,id_value=str(value_id))
    sql_full_patern="select t.{id} as parent_id,t_base.{id} as children_id,t_base.obj as obj from ({sql_1}) as t ,({sql_2}) as t_base where t.obj  Intersects t_base.obj"
    sql_full=sql_full_patern.format(id=name_id,sql_1=sql_format_base,sql_2=sql_next)
    query = data_manager.query_hidden(sql_full, TypeSqlDialect.sqlite)
    return query
name_table='StreetGSK7_v_test_no_poligon'
sql_prepare = "Select RowNum() as id___dxx,* From " + name_table
name_id='id___dxx'
tab_id=data_manager.query(sql_prepare,TypeSqlDialect.sqlite)
tab_base = tab_id
count_row=tab_base.count()
i=0
start_time=datetime.now()
count_lim=100
for ft in tab_base.items():
    i=i+1
    if i>count_lim:
        break
    id_val = ft[name_id]
    query = findIntersections(tab_id.name, name_id, id_val)
    if query.count() == 0:
        query.close()
        continue
        #SplitIntersection(self.__tab_base, query, name_id, id_val)
    query.close()
tab_id.close()
end_time=datetime.now()
print("Time find:"+str(end_time-start_time))